package com.example.blum.restcalc3;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Button btnCalc = (Button) findViewById(R.id.btnCalc);
        final EditText etBill = (EditText) findViewById(R.id.etBill);
        final RadioGroup rgTip = (RadioGroup)  findViewById(R.id.rgTip);
        final TextView tvResult = (TextView) findViewById(R.id.tvResult);

        //*****************************************************************************************
        /*
        When user clicks button get tip and bill amount, calculate and display total
         */
        btnCalc.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                int radio_id = rgTip.getCheckedRadioButtonId();
                Toast.makeText(getApplicationContext(),""+radio_id, Toast.LENGTH_LONG).show();
                // radio_id is -1 if none selected

                if(radio_id==-1){
                    //if no radio button selected
                    Toast.makeText(getApplicationContext(),"Please select a tip amount", Toast.LENGTH_LONG).show();
                }else {
                    RadioButton myRad = (RadioButton) findViewById(radio_id);
                    Double tip = Double.parseDouble(myRad.getText().toString())/100.0;
                    Double bill=0.0;
                    try {
                        bill = Double.parseDouble(etBill.getText().toString());
                        Double result = bill*(1+tip);
                        tvResult.setText("$"+String.format("%.2f", result));
                        //the tag is hidden from the user but useful to the coder
                        Toast.makeText(getApplicationContext(),myRad.getTag().toString(), Toast.LENGTH_LONG).show();

                    }catch(Exception e){
                        //if no amount entered for bill
                        Toast.makeText(getApplicationContext(),"Please enter a number for the bill amount", Toast.LENGTH_LONG).show();
                    }

                }
            }//end onClick
        });//end setOnClickListener

        //*****************************************************************************************
        /*
        when user changes bill amount, clear out result
         */
        etBill.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                tvResult.setText("-----------------");
            }

            @Override
            public void afterTextChanged(Editable editable) {

            }
        });//end addTextChangedListener

        //*****************************************************************************************
        /*
        when user changes which radio button is checked
         */
        //https://stackoverflow.com/questions/6780981/android-radiogroup-how-to-configure-the-event-listener
        rgTip.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener()
        {
            public void onCheckedChanged(RadioGroup group, int checkedId)
            {
                tvResult.setText("-----------------");
            }
        });


    }//end onCreate
}//end MainActivity

